// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITBLAME_H
#define GITBLAME_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/repository.h"
#include "../include/blame_options.h"
#include "../include/blame_hunk.h"

using namespace node;
using namespace v8;

class GitBlame : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_blame *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_blame *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;
  GitBlame(git_blame *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  ~GitBlame();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  struct BufferBaton {
    int error_code;
    const git_error* error;
    git_blame * out;
    git_blame * reference;
    const char * buffer;
    size_t buffer_len;
  };
  class BufferWorker : public Nan::AsyncWorker {
  public:
    BufferWorker(
      BufferBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~BufferWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    BufferBaton *baton;
  };

  static NAN_METHOD(Buffer);

  struct FileBaton {
    int error_code;
    const git_error* error;
    git_blame * out;
    git_repository * repo;
    const char * path;
    git_blame_options * options;
  };
  class FileWorker : public Nan::AsyncWorker {
  public:
    FileWorker(
      FileBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~FileWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    FileBaton *baton;
  };

  static NAN_METHOD(File);

  static NAN_METHOD(Free);

  static NAN_METHOD(GetHunkByindex);

  static NAN_METHOD(GetHunkByline);

  static NAN_METHOD(GetHunkCount);

  static NAN_METHOD(InitOptions);
  git_blame *raw;
};

#endif
