// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITHASHSIG_H
#define GITHASHSIG_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
#include <git2/sys/hashsig.h>
}

#include "../include/typedefs.h"

// Forward declaration.
struct git_hashsig {
};

using namespace node;
using namespace v8;

class GitHashsig : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_hashsig *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_hashsig *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;
  GitHashsig(git_hashsig *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  ~GitHashsig();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  static NAN_METHOD(Compare);

  struct CreateBaton {
    int error_code;
    const git_error* error;
    git_hashsig * out;
    const char * buf;
    size_t buflen;
    git_hashsig_option_t opts;
  };
  class CreateWorker : public Nan::AsyncWorker {
  public:
    CreateWorker(
      CreateBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~CreateWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    CreateBaton *baton;
  };

  static NAN_METHOD(Create);

  struct CreateFromfileBaton {
    int error_code;
    const git_error* error;
    git_hashsig * out;
    const char * path;
    git_hashsig_option_t opts;
  };
  class CreateFromfileWorker : public Nan::AsyncWorker {
  public:
    CreateFromfileWorker(
      CreateFromfileBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~CreateFromfileWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    CreateFromfileBaton *baton;
  };

  static NAN_METHOD(CreateFromfile);

  static NAN_METHOD(Free);
  git_hashsig *raw;
};

#endif
