// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITIGNORE_H
#define GITIGNORE_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/repository.h"

using namespace node;
using namespace v8;

class GitIgnore : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  static NAN_METHOD(AddRule);

  static NAN_METHOD(ClearInternalRules);

  struct PathIsIgnoredBaton {
    int error_code;
    const git_error* error;
    int * ignored;
    git_repository * repo;
    const char * path;
  };
  class PathIsIgnoredWorker : public Nan::AsyncWorker {
  public:
    PathIsIgnoredWorker(
      PathIsIgnoredBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~PathIsIgnoredWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    PathIsIgnoredBaton *baton;
  };

  static NAN_METHOD(PathIsIgnored);
};

#endif
