// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITPACKBUILDER_H
#define GITPACKBUILDER_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/oid.h"
#include "../include/revwalk.h"
#include "../include/repository.h"
// Forward declaration.
struct git_packbuilder {
};

using namespace node;
using namespace v8;

class GitPackbuilder : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_packbuilder *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_packbuilder *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;
  GitPackbuilder(git_packbuilder *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  ~GitPackbuilder();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  static NAN_METHOD(Free);

  static NAN_METHOD(Hash);

  static NAN_METHOD(Insert);

  static NAN_METHOD(InsertCommit);

  static NAN_METHOD(InsertRecur);

  static NAN_METHOD(InsertTree);

  static NAN_METHOD(InsertWalk);

  static NAN_METHOD(Create);

  static NAN_METHOD(ObjectCount);

  static NAN_METHOD(SetThreads);

  static NAN_METHOD(Written);
  git_packbuilder *raw;
};

#endif
