// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITRESET_H
#define GITRESET_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/repository.h"
#include "../include/object.h"
#include "../include/checkout_options.h"
#include "../include/strarray.h"
#include "../include/annotated_commit.h"

using namespace node;
using namespace v8;

class GitReset : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  struct ResetBaton {
    int error_code;
    const git_error* error;
    git_repository * repo;
    git_object * target;
    git_reset_t reset_type;
    git_checkout_options * checkout_opts;
  };
  class ResetWorker : public Nan::AsyncWorker {
  public:
    ResetWorker(
      ResetBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~ResetWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    ResetBaton *baton;
  };

  static NAN_METHOD(Reset);

  struct DefaultBaton {
    int error_code;
    const git_error* error;
    git_repository * repo;
    git_object * target;
    git_strarray * pathspecs;
  };
  class DefaultWorker : public Nan::AsyncWorker {
  public:
    DefaultWorker(
      DefaultBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~DefaultWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    DefaultBaton *baton;
  };

  static NAN_METHOD(Default);

  static NAN_METHOD(FromAnnotated);
};

#endif
