// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITSTATUSLIST_H
#define GITSTATUSLIST_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/diff_perfdata.h"
#include "../include/repository.h"
#include "../include/status_options.h"
// Forward declaration.
struct git_status_list {
};

using namespace node;
using namespace v8;

class GitStatusList : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_status_list *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_status_list *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;
  GitStatusList(git_status_list *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  ~GitStatusList();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  static NAN_METHOD(Entrycount);

  static NAN_METHOD(Free);

  struct GetPerfdataBaton {
    int error_code;
    const git_error* error;
    git_diff_perfdata * out;
    const git_status_list * status;
  };
  class GetPerfdataWorker : public Nan::AsyncWorker {
  public:
    GetPerfdataWorker(
      GetPerfdataBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~GetPerfdataWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    GetPerfdataBaton *baton;
  };

  static NAN_METHOD(GetPerfdata);

  struct CreateBaton {
    int error_code;
    const git_error* error;
    git_status_list * out;
    git_repository * repo;
    const git_status_options * opts;
  };
  class CreateWorker : public Nan::AsyncWorker {
  public:
    CreateWorker(
      CreateBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~CreateWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    CreateBaton *baton;
  };

  static NAN_METHOD(Create);
  git_status_list *raw;
};

#endif
