// This is a generated file, modify: generate/templates/class_header.h

#ifndef GITTRANSPORT_H
#define GITTRANSPORT_H
#include <nan.h>
#include <string>
#include <queue>
#include <utility>

#include "async_baton.h"
#include "promise_completion.h"

extern "C" {
#include <git2.h>
#include <git2/sys/transport.h>
}

#include "../include/typedefs.h"

#include "../include/remote.h"

using namespace node;
using namespace v8;

class GitTransport : public Nan::ObjectWrap {
public:

  static Nan::Persistent<Function> constructor_template;
  static void InitializeComponent (Local<v8::Object> target);
  // diagnostic count of self-freeing object instances
  static int SelfFreeingInstanceCount;
  // diagnostic count of constructed non-self-freeing object instances
  static int NonSelfFreeingConstructedCount;

  git_transport *GetValue();
  void ClearValue();

  static Local<v8::Value> New(const git_transport *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  bool selfFreeing;



private:
  // owner of the object, in the memory management sense. only populated
  // when using ownedByThis, and the type doesn't have a dupFunction
  // CopyablePersistentTraits are used to get the reset-on-destruct behavior.
  Nan::Persistent<Object, Nan::CopyablePersistentTraits<Object> > owner;
  GitTransport(git_transport *raw, bool selfFreeing, Local<v8::Object> owner = Local<v8::Object>());
  ~GitTransport();

  static NAN_METHOD(JSNewFunction);
  static NAN_METHOD(GetSelfFreeingInstanceCount);
  static NAN_METHOD(GetNonSelfFreeingConstructedCount);


  static NAN_METHOD(Init);

  struct SshWithPathsBaton {
    int error_code;
    const git_error* error;
    git_transport * out;
    git_remote * owner;
    void * payload;
  };
  class SshWithPathsWorker : public Nan::AsyncWorker {
  public:
    SshWithPathsWorker(
      SshWithPathsBaton *_baton,
      Nan::Callback *callback
    ) : Nan::AsyncWorker(callback)
      , baton(_baton) {};
    ~SshWithPathsWorker() {};
    void Execute();
    void HandleOKCallback();

  private:
    SshWithPathsBaton *baton;
  };

  static NAN_METHOD(SshWithPaths);

  static NAN_METHOD(Unregister);

  struct SshWithPaths_globalPayload {

    SshWithPaths_globalPayload() {
    }

    ~SshWithPaths_globalPayload() {
    }
  };
  git_transport *raw;
};

#endif
