// This is a generated file, modify: generate/templates/class_content.cc

#include <nan.h>
#include <string.h>

extern "C" {
#include <git2.h>
#include <git2/sys/diff.h>
}

#include "../include/lock_master.h"
#include "../include/functions/copy.h"
#include "../include/diff_perfdata.h"
#include "../include/functions/sleep_for_ms.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitDiffPerfdata::GitDiffPerfdata(git_diff_perfdata *raw, bool selfFreeing, Local<v8::Object> owner)
{
  if (!owner.IsEmpty()) {
    // if we have an owner, there are two options - either we duplicate the raw object
    // (so we own the duplicate, and can self-free it)
    // or we keep a handle on the owner so it doesn't get garbage collected
    // while this wrapper is accessible
    this->owner.Reset(owner);
    this->raw = raw;
  } else {
    this->raw = raw;
  }
  this->selfFreeing = selfFreeing;

  if (selfFreeing) {
    SelfFreeingInstanceCount++;
  } else {
    NonSelfFreeingConstructedCount++;
  }

}

GitDiffPerfdata::~GitDiffPerfdata()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.
}

void GitDiffPerfdata::InitializeComponent(Local<v8::Object> target)
{
  Nan::HandleScope scope;

  Local<FunctionTemplate> tpl = Nan::New<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(Nan::New("DiffPerfdata").ToLocalChecked());

  Nan::SetPrototypeMethod(tpl, "version", Version);
  Nan::SetPrototypeMethod(tpl, "statCalls", StatCalls);
  Nan::SetPrototypeMethod(tpl, "oidCalculations", OidCalculations);

  Nan::SetMethod(tpl, "getSelfFreeingInstanceCount", GetSelfFreeingInstanceCount);
  Nan::SetMethod(tpl, "getNonSelfFreeingConstructedCount", GetNonSelfFreeingConstructedCount);

  Local<Function> _constructor_template = Nan::GetFunction(tpl).ToLocalChecked();
  constructor_template.Reset(_constructor_template);
  Nan::Set(target, Nan::New("DiffPerfdata").ToLocalChecked(), _constructor_template);
}

NAN_METHOD(GitDiffPerfdata::JSNewFunction)
{

  if (info.Length() == 0 || !info[0]->IsExternal()) {
    return Nan::ThrowError("A new GitDiffPerfdata cannot be instantiated.");
  }

  GitDiffPerfdata* object = new GitDiffPerfdata(static_cast<git_diff_perfdata *>(
        Local<External>::Cast(info[0])->Value()),
      Nan::To<bool>(info[1]).FromJust(),
      info.Length() >= 3 && !info[2].IsEmpty() && info[2]->IsObject() ? info[2]->ToObject() : Local<v8::Object>()
                                               );
  object->Wrap(info.This());

  info.GetReturnValue().Set(info.This());
}

Local<v8::Value> GitDiffPerfdata::New(const git_diff_perfdata *raw, bool selfFreeing, Local<v8::Object> owner)
{
  Nan::EscapableHandleScope scope;
  Local<v8::Value> argv[3] = { Nan::New<External>((void *)raw), Nan::New(selfFreeing), owner };
  return scope.Escape(
           Nan::NewInstance(
             Nan::New(GitDiffPerfdata::constructor_template),
             owner.IsEmpty() ? 2 : 3, // passing an empty handle as part of the arguments causes a crash
             argv
           ).ToLocalChecked());
}

NAN_METHOD(GitDiffPerfdata::GetSelfFreeingInstanceCount)
{
  info.GetReturnValue().Set(SelfFreeingInstanceCount);
}

NAN_METHOD(GitDiffPerfdata::GetNonSelfFreeingConstructedCount)
{
  info.GetReturnValue().Set(NonSelfFreeingConstructedCount);
}

git_diff_perfdata *GitDiffPerfdata::GetValue()
{
  return this->raw;
}

void GitDiffPerfdata::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitDiffPerfdata::Version)
{
  Local<v8::Value> to;

  unsigned int
  version =
    Nan::ObjectWrap::Unwrap<GitDiffPerfdata>(info.This())->GetValue()->version;
// start convert_to_v8 block
  to = Nan::New<Number>( version);
  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
NAN_METHOD(GitDiffPerfdata::StatCalls)
{
  Local<v8::Value> to;

  size_t
  stat_calls =
    Nan::ObjectWrap::Unwrap<GitDiffPerfdata>(info.This())->GetValue()->stat_calls;
// start convert_to_v8 block
  to = Nan::New<Number>( stat_calls);
  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
NAN_METHOD(GitDiffPerfdata::OidCalculations)
{
  Local<v8::Value> to;

  size_t
  oid_calculations =
    Nan::ObjectWrap::Unwrap<GitDiffPerfdata>(info.This())->GetValue()->oid_calculations;
// start convert_to_v8 block
  to = Nan::New<Number>( oid_calculations);
  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
Nan::Persistent<Function> GitDiffPerfdata::constructor_template;

int GitDiffPerfdata::SelfFreeingInstanceCount;
int GitDiffPerfdata::NonSelfFreeingConstructedCount;
