// This is a generated file, modify: generate/templates/class_content.cc

#include <nan.h>
#include <string.h>

extern "C" {
#include <git2.h>
}

#include "../include/lock_master.h"
#include "../include/functions/copy.h"
#include "../include/oidarray.h"
#include "../include/functions/sleep_for_ms.h"

#include "../include/oid.h"

#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitOidarray::GitOidarray(git_oidarray *raw, bool selfFreeing, Local<v8::Object> owner)
{
  if (!owner.IsEmpty()) {
    // if we have an owner, there are two options - either we duplicate the raw object
    // (so we own the duplicate, and can self-free it)
    // or we keep a handle on the owner so it doesn't get garbage collected
    // while this wrapper is accessible
    this->owner.Reset(owner);
    this->raw = raw;
  } else {
    this->raw = raw;
  }
  this->selfFreeing = selfFreeing;

  if (selfFreeing) {
    SelfFreeingInstanceCount++;
  } else {
    NonSelfFreeingConstructedCount++;
  }

}

GitOidarray::~GitOidarray()
{
  if (this->selfFreeing) {
    git_oidarray_free(this->raw);
    SelfFreeingInstanceCount--;

    this->raw = NULL;
  }

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.
}

void GitOidarray::InitializeComponent(Local<v8::Object> target)
{
  Nan::HandleScope scope;

  Local<FunctionTemplate> tpl = Nan::New<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(Nan::New("Oidarray").ToLocalChecked());

  Nan::SetPrototypeMethod(tpl, "free", Free);
  Nan::SetPrototypeMethod(tpl, "ids", Ids);
  Nan::SetPrototypeMethod(tpl, "count", Count);

  Nan::SetMethod(tpl, "getSelfFreeingInstanceCount", GetSelfFreeingInstanceCount);
  Nan::SetMethod(tpl, "getNonSelfFreeingConstructedCount", GetNonSelfFreeingConstructedCount);

  Local<Function> _constructor_template = Nan::GetFunction(tpl).ToLocalChecked();
  constructor_template.Reset(_constructor_template);
  Nan::Set(target, Nan::New("Oidarray").ToLocalChecked(), _constructor_template);
}

NAN_METHOD(GitOidarray::JSNewFunction)
{

  if (info.Length() == 0 || !info[0]->IsExternal()) {
    return Nan::ThrowError("A new GitOidarray cannot be instantiated.");
  }

  GitOidarray* object = new GitOidarray(static_cast<git_oidarray *>(
                                          Local<External>::Cast(info[0])->Value()),
                                        Nan::To<bool>(info[1]).FromJust(),
                                        info.Length() >= 3 && !info[2].IsEmpty() && info[2]->IsObject() ? info[2]->ToObject() : Local<v8::Object>()
                                       );
  object->Wrap(info.This());

  info.GetReturnValue().Set(info.This());
}

Local<v8::Value> GitOidarray::New(const git_oidarray *raw, bool selfFreeing, Local<v8::Object> owner)
{
  Nan::EscapableHandleScope scope;
  Local<v8::Value> argv[3] = { Nan::New<External>((void *)raw), Nan::New(selfFreeing), owner };
  return scope.Escape(
           Nan::NewInstance(
             Nan::New(GitOidarray::constructor_template),
             owner.IsEmpty() ? 2 : 3, // passing an empty handle as part of the arguments causes a crash
             argv
           ).ToLocalChecked());
}

NAN_METHOD(GitOidarray::GetSelfFreeingInstanceCount)
{
  info.GetReturnValue().Set(SelfFreeingInstanceCount);
}

NAN_METHOD(GitOidarray::GetNonSelfFreeingConstructedCount)
{
  info.GetReturnValue().Set(NonSelfFreeingConstructedCount);
}

git_oidarray *GitOidarray::GetValue()
{
  return this->raw;
}

void GitOidarray::ClearValue()
{
  this->raw = NULL;
}


/*
     */
NAN_METHOD(GitOidarray::Free)
{
  Nan::EscapableHandleScope scope;

  if (Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->GetValue() != NULL) {

    giterr_clear();

    {
      LockMaster lockMaster(/*asyncAction: */false        ,    Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->GetValue()
                           );

      git_oidarray_free(
        Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->GetValue()
      );

      Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->ClearValue();
    }
    return info.GetReturnValue().Set(scope.Escape(Nan::Undefined()));
  }
}
NAN_METHOD(GitOidarray::Ids)
{
  Local<v8::Value> to;

  git_oid *
  ids =
    Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->GetValue()->ids;
// start convert_to_v8 block

  if (ids != NULL) {
    // GitOid ids
    to = GitOid::New(ids, false  );
  } else {
    to = Nan::Null();
  }

// end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
NAN_METHOD(GitOidarray::Count)
{
  Local<v8::Value> to;

  size_t
  count =
    Nan::ObjectWrap::Unwrap<GitOidarray>(info.This())->GetValue()->count;
// start convert_to_v8 block
  to = Nan::New<Number>( count);
  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
Nan::Persistent<Function> GitOidarray::constructor_template;

int GitOidarray::SelfFreeingInstanceCount;
int GitOidarray::NonSelfFreeingConstructedCount;
