// This is a generated file, modify: generate/templates/class_content.cc

#include <nan.h>
#include <string.h>

extern "C" {
#include <git2.h>
#include <git2/cred_helpers.h>
}

#include "../include/lock_master.h"
#include "../include/functions/copy.h"
#include "../include/cred_userpass_payload.h"
#include "../include/functions/sleep_for_ms.h"


#include <iostream>

using namespace std;
using namespace v8;
using namespace node;

GitCredUserpassPayload::GitCredUserpassPayload(git_cred_userpass_payload *raw, bool selfFreeing, Local<v8::Object> owner)
{
  if (!owner.IsEmpty()) {
    // if we have an owner, there are two options - either we duplicate the raw object
    // (so we own the duplicate, and can self-free it)
    // or we keep a handle on the owner so it doesn't get garbage collected
    // while this wrapper is accessible
    this->owner.Reset(owner);
    this->raw = raw;
  } else {
    this->raw = raw;
  }
  this->selfFreeing = selfFreeing;

  if (selfFreeing) {
    SelfFreeingInstanceCount++;
  } else {
    NonSelfFreeingConstructedCount++;
  }

}

GitCredUserpassPayload::~GitCredUserpassPayload()
{

  // this will cause an error if you have a non-self-freeing object that also needs
  // to save values. Since the object that will eventually free the object has no
  // way of knowing to free these values.
}

void GitCredUserpassPayload::InitializeComponent(Local<v8::Object> target)
{
  Nan::HandleScope scope;

  Local<FunctionTemplate> tpl = Nan::New<FunctionTemplate>(JSNewFunction);

  tpl->InstanceTemplate()->SetInternalFieldCount(1);
  tpl->SetClassName(Nan::New("CredUserpassPayload").ToLocalChecked());

  Nan::SetPrototypeMethod(tpl, "username", Username);
  Nan::SetPrototypeMethod(tpl, "password", Password);

  Nan::SetMethod(tpl, "getSelfFreeingInstanceCount", GetSelfFreeingInstanceCount);
  Nan::SetMethod(tpl, "getNonSelfFreeingConstructedCount", GetNonSelfFreeingConstructedCount);

  Local<Function> _constructor_template = Nan::GetFunction(tpl).ToLocalChecked();
  constructor_template.Reset(_constructor_template);
  Nan::Set(target, Nan::New("CredUserpassPayload").ToLocalChecked(), _constructor_template);
}

NAN_METHOD(GitCredUserpassPayload::JSNewFunction)
{

  if (info.Length() == 0 || !info[0]->IsExternal()) {
    return Nan::ThrowError("A new GitCredUserpassPayload cannot be instantiated.");
  }

  GitCredUserpassPayload* object = new GitCredUserpassPayload(static_cast<git_cred_userpass_payload *>(
        Local<External>::Cast(info[0])->Value()),
      Nan::To<bool>(info[1]).FromJust(),
      info.Length() >= 3 && !info[2].IsEmpty() && info[2]->IsObject() ? info[2]->ToObject() : Local<v8::Object>()
                                                             );
  object->Wrap(info.This());

  info.GetReturnValue().Set(info.This());
}

Local<v8::Value> GitCredUserpassPayload::New(const git_cred_userpass_payload *raw, bool selfFreeing, Local<v8::Object> owner)
{
  Nan::EscapableHandleScope scope;
  Local<v8::Value> argv[3] = { Nan::New<External>((void *)raw), Nan::New(selfFreeing), owner };
  return scope.Escape(
           Nan::NewInstance(
             Nan::New(GitCredUserpassPayload::constructor_template),
             owner.IsEmpty() ? 2 : 3, // passing an empty handle as part of the arguments causes a crash
             argv
           ).ToLocalChecked());
}

NAN_METHOD(GitCredUserpassPayload::GetSelfFreeingInstanceCount)
{
  info.GetReturnValue().Set(SelfFreeingInstanceCount);
}

NAN_METHOD(GitCredUserpassPayload::GetNonSelfFreeingConstructedCount)
{
  info.GetReturnValue().Set(NonSelfFreeingConstructedCount);
}

git_cred_userpass_payload *GitCredUserpassPayload::GetValue()
{
  return this->raw;
}

void GitCredUserpassPayload::ClearValue()
{
  this->raw = NULL;
}

NAN_METHOD(GitCredUserpassPayload::Username)
{
  Local<v8::Value> to;

  const char *
  username =
    Nan::ObjectWrap::Unwrap<GitCredUserpassPayload>(info.This())->GetValue()->username;
// start convert_to_v8 block
  if (username) {
    to = Nan::New<String>(username).ToLocalChecked();
  } else {
    to = Nan::Null();
  }

  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
NAN_METHOD(GitCredUserpassPayload::Password)
{
  Local<v8::Value> to;

  const char *
  password =
    Nan::ObjectWrap::Unwrap<GitCredUserpassPayload>(info.This())->GetValue()->password;
// start convert_to_v8 block
  if (password) {
    to = Nan::New<String>(password).ToLocalChecked();
  } else {
    to = Nan::Null();
  }

  // end convert_to_v8 block
  info.GetReturnValue().Set(to);
}
Nan::Persistent<Function> GitCredUserpassPayload::constructor_template;

int GitCredUserpassPayload::SelfFreeingInstanceCount;
int GitCredUserpassPayload::NonSelfFreeingConstructedCount;
